Subject: bug#23263: closed (Re: bug#23263: cat: missingfile: No such file or directory)

From: [email-masked] (GNU bug Tracking System)
Date: Sun, 10 Apr 2016 19:02:01 +0000

Your bug report

#23263: cat: missingfile: No such file or directory

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
23263: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=23263
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#23263: cat: missingfile: No such file or directory
From: Paul Eggert <[email-masked]>
To: Jonny Grant <[email-masked]>, [email-masked]
Date: Sun, 10 Apr 2016 12:01:09 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

Jonny Grant wrote:
> Hello
>
> I noticed that cat doesn't have an accurate message in the following use-case:
>
> $ cat missingfile
> cat: missingfile: No such file or directory
> $ mkdir testdir
> $ cat testdir
> cat: testdir: Is a directory

The "No such file or directory" message occurs because the operating system does 
not have a separate error code for missing directory versus missing file. In the 
example you gave, perhaps the working directory is missing (this can happen on 
some systems), or perhaps there is no file named "missingfile" in the working 
directory; the same code is returned for both situations.

This is not a coreutils issue, but is instead a kernel and C library issue. It's 
not something that coreutils can "fix", even assuming it was agreed that it was 
a bug. If it really bothers you, I suggest writing the POSIX standardization 
committee, but I should warn you that you'll need a strong argument to change 
something that has been standardized for decades.

Subject: cat: missingfile: No such file or directory
From: Jonny Grant <[email-masked]>
To: [email-masked]
Date: Sun, 10 Apr 2016 19:43:32 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello

I noticed that cat doesn't have an accurate message in the following 
use-case:

$ cat missingfile
cat: missingfile: No such file or directory
$ mkdir testdir
$ cat testdir
cat: testdir: Is a directory

I wrote up the details of the ENOENT problem here:
http://technoramauk.blogspot.co.uk/2015/12/enoent-considered-harmful.html

Please keep my email address in any replies as I am not on this mailing 
list.

Cheers, Jonny